// Flat Shading 3D Engine header file - FS3DE.HPP - by Kent Dahl
/* O.O.P. approach
Start:	28 / 02 - 1997
Update: 09 / 03 - 1997
*/
#ifndef __FS3DE_HPP
#define __FS3DE_HPP

#include "dos640k.hpp"
#include "3dmath.hpp"   //KDIV\INCLUDE
#include "lists.hpp" //KDIV\INCLUDE

//Graphic stuff .... VERY unstructured... XLIB-specific
unsigned int PageScr[2];
unsigned int& LogicalScr = PageScr[1];
unsigned int& PhysicalScr = PageScr[2];


typedef unsigned int ColorIndex_t;
#define NUM_SHADES 64
FP_type NearZPlane=0.5;

/////////////////////////
//Face_t
class Face_t {
	public:
		ListIndex_t fv[3], normal;
		ColorIndex_t color;

	public:
		Face_t();
		Face_t(ListIndex_t, ListIndex_t, ListIndex_t,
					 ListIndex_t, ColorIndex_t);
};

class Face2D_t {
	public:
		ListIndex_t fp[3];
		ColorIndex_t color;
		//FP_type depth;
	public:
		Face2D_t();
		Face2D_t(ListIndex_t, ListIndex_t, ListIndex_t, ColorIndex_t);
		//boolean operator >(Face2D_t);
};
//////
class VertexList : public SimpleList<point_t>
{
	public:
		VertexList(ListIndex_t);// : SimpleList<point_t>(n){};
};

class ScreenCoordsList : public SimpleList<point2D_t>
{
	public:
		ScreenCoordsList(ListIndex_t);// : SimpleList<point2D_t>(n){};
};

class FaceList : public SimpleList<Face_t>
{
 public:
	FaceList(ListIndex_t);// : SimpleList<Face_t>(n){};
};
class NormalList : public SimpleList<point_t>
{public:
	NormalList(ListIndex_t);// : SimpleList<point_t>(n){};
};

class Face2DList : public SimpleList<Face2D_t>
{public:
	Face2DList(ListIndex_t);// : SimpleList<Face2D_t>(n){};
};
/////////////////////////
class SimpleObjData
{
	protected:
		VertexList *VL;
		NormalList *NL;
		FaceList	*FL;
	public:
		SimpleObjData(VertexList* , NormalList* , FaceList* );
		void AddToScreenSpaceAt(Position6D_t);
};

class DepthSortIndex {
	public:
		ListIndex_t I;
		FP_type Z;
	public:
		DepthSortIndex();// : I(0), Z(0) {};
		DepthSortIndex(ListIndex_t, FP_type);// : I(i), Z(z) {};
		boolean operator >(DepthSortIndex);//{ return (Z>D2.Z ? TRUE : FALSE ); }
};

class DepthSortIndexList : public SortableList<DepthSortIndex> {
	public:
		DepthSortIndexList(WORD);// : SortableList<DepthSortIndex>(n) { };
		void AddSorted(DepthSortIndex);
};


/////////////////////////
class Entity_t : public Position6D_t
{
	SimpleObjData *OD;
};

class EntityList : public SortableList<Entity_t>
{	};

class WorldSpace
{	};

/////////////////////////
class WorldSpaceData_t
{
	protected:
		EntityList *EL;
		WorldSpace *WS;
	public:
		WorldSpaceData_t();//{};
		WorldSpaceData_t(EntityList* , WorldSpace* );// : EL(e), WS(w){};
};
/////////////////////////

class ViewSpace
{
	protected:
		WorldSpaceData_t *WSD;
		ListIndex_t IPOVE; //Index to POV Entity
};

/////////////////////////

class ScreenSpace_t {
	public:
		Position6D_t* Camera;
		ScreenCoordsList *SCL;
		Face2DList *F2DL;
		DepthSortIndexList *DSIL;
	public:
		ScreenSpace_t(ListIndex_t, ListIndex_t);
		ScreenSpace_t();
		void Clear();
		void Draw();
};


class FlatShading3DEngine {
	protected:
	public:
		ScreenSpace_t* ScreenSpace;
		//VertexList* TmpVL;
		//NormalList* TmpNL;

	public:
		FlatShading3DEngine();
		void SetCurrent();
		void Draw();
		void ClearOutput();
};

#endif //End-of-file