// Flat Shading 3D Engine Test- FS3DE_T - by Kent Dahl
/* O.O.P. approach
Start:	28 / 02 - 1997
Update: 09 / 03 - 1997
*/

#include "dos640k.hpp"
#include "Xlib_all.h"   //XLIB
#include "fs3de.cpp" //KDIV\FS3DE
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include "xprintf.c"

#define FallOffDistance 25
#define WIDTH (256+128+32)
 //512

void PageFlip(){
	x_page_flip(0,0);
	unsigned int tmp = PageScr[0];
	PageScr[0]=PageScr[1];
	PageScr[1]=tmp;
}
//
FlatShading3DEngine *MyFS3DE;

void ScreenSpace_t::Draw(){
	point2D_t p, sp[3];
	DSIL->ResetStart();
	//F2DL->ResetStart();
	if(DSIL->NumOfElems())
	do{      //sp[0]=SCL->operator[](F2DL->Current().fp[0]);
		sp[0]=SCL->operator[](F2DL->operator[](DSIL->Current().I).fp[0]);
		sp[1]=SCL->operator[](F2DL->operator[](DSIL->Current().I).fp[1]);
		sp[2]=SCL->operator[](F2DL->operator[](DSIL->Current().I).fp[2]);

		x_triangle(sp[0].V(0), sp[0].V(1),
							 sp[1].V(0), sp[1].V(1),
							 sp[2].V(0), sp[2].V(1),
							 F2DL->operator[](DSIL->Current().I).color, LogicalScr	);
	 /*							SCL->[F2DL->Current().fp[0].v(0),

		int x0, int y0, int x1, int y1, int x2, int y2,
				 WORD color, WORD PageBase);  */

	}while(++(*DSIL));

	/*
	SCL->ResetStart();
	do{
		p=SCL->Current();/* + point2D_t(ScrnPhysicalPixelWidth>>1,
											ScrnPhysicalHeight>>1);
		if( (unsigned int) p.V(0)<ScrnPhysicalPixelWidth
				&& (unsigned int) p.V(1)<ScrnPhysicalHeight)
					x_put_pix(p.V(0),p.V(1),LogicalScr,63);
	}while(++(*SCL));
	*/
}

#define num_vertex 512
/*class SortVL {
	public:
		ListIndex_t I;				FP_type Z;
		SortVL() : I(0), Z(0) {};
		SortVL(ListIndex_t i, FP_type z) : I(i), Z(z) {};
		inline boolean operator >(SortVL VL2){ return (Z>VL2.Z ? TRUE : FALSE ); }
};*/
//Main loop
void Run_Loop(){
	Position6D_t Observer, ObjPos, ObjPos2, ObjPos3;
	FaceList MyFL(num_vertex); NormalList MyNL(num_vertex);
	VertexList VL(num_vertex);
	ObjPos=ObjPos+point_t(0,0,30);
	ObjPos2=ObjPos2+point_t(20,0,40);
	SimpleObjData My3DObj(&VL, &MyNL, &MyFL);
	ObjPos3=ObjPos3+point_t(0,0,50);

	char ch;

	pMatrix_t ObjMatrix;
	point_t P;
	VL.EmptyList();		MyNL.EmptyList();  MyFL.EmptyList();
	VL.Add(point_t(-5,-5,-5));//0    0-1
	VL.Add(point_t( 5,-5,-5));//1    |/|
	VL.Add(point_t(-5, 5,-5));//2    2-3   4---5
	VL.Add(point_t( 5, 5,-5));//3     \   |  /|
	VL.Add(point_t(-5,-5,5));//4         \ |/  |
	VL.Add(point_t( 5,-5,5));//5           6---7
	VL.Add(point_t(-5, 5,5));//6
	VL.Add(point_t( 5, 5,5));//7

	MyNL.Add(GetNormal(VL[1]-VL[0], VL[2]-VL[0]));//n0  In
	MyNL.Add(GetNormal(VL[6]-VL[5], VL[7]-VL[5]));//n1  Out
	MyNL.Add(GetNormal(VL[5]-VL[4], VL[1]-VL[4]));//n2  Up
	MyNL.Add(GetNormal(VL[2]-VL[6], VL[3]-VL[6]));//n3  Down
	MyNL.Add(GetNormal(VL[4]-VL[6], VL[0]-VL[6]));//n4  Left
	MyNL.Add(GetNormal(VL[5]-VL[1], VL[7]-VL[1]));//n5  Right



	MyFL.Add(Face_t(0,1,2,0,1)); //v0,v1,v2,n,c
	MyFL.Add(Face_t(1,2,3,0,1)); //v0,v1,v2,n,c
	MyFL.Add(Face_t(4,5,6,1,2));
	MyFL.Add(Face_t(5,6,7,1,2));
	MyFL.Add(Face_t(4,5,1,2,3));
	MyFL.Add(Face_t(0,1,4,2,3));
	MyFL.Add(Face_t(6,7,2,3,0));
	MyFL.Add(Face_t(7,2,3,3,0));
	MyFL.Add(Face_t(4,6,0,4,4));
	MyFL.Add(Face_t(0,6,2,4,4));
	MyFL.Add(Face_t(1,5,7,5,3));
	MyFL.Add(Face_t(1,3,7,5,3));





	MyFS3DE->ScreenSpace->Camera =&Observer;

	do{
		MyFS3DE->ClearOutput();

		x_rect_fill(0,0,ScrnPhysicalPixelWidth, ScrnPhysicalHeight,
								LogicalScr,0);
		My3DObj.AddToScreenSpaceAt(ObjPos);
		My3DObj.AddToScreenSpaceAt(ObjPos2);
		My3DObj.AddToScreenSpaceAt((ObjPos3));



		MyFS3DE->Draw();
		x_wait_vsync();
		PageFlip();
		if(kbhit()){
			ch=getch();
			switch (ch) {
				case '+' : Observer=Observer+point_t( 0, 0, 5); break;
				case '-' : Observer=Observer-point_t( 0, 0, 5); break;
				case 'a' : ObjPos3=ObjPos3+point_t( 0, 0, 5); break;
				case 'z' : ObjPos3=ObjPos3-point_t( 0, 0, 5); break;

				case '1' : Observer=Observer-point_t( 5, 0, 0); break;
				case '3' : Observer=Observer+point_t( 5, 0, 0); break;
				case '8' : ObjPos.Rotate(0, 5); break;
				case '2' : ObjPos.Rotate(0,-5); break;
				case '6' : ObjPos.Rotate(1, 5); break;
				case '4' : ObjPos.Rotate(1,-5); break;
				case '9' : ObjPos.Rotate(2, 5); break;
				case '7' : ObjPos.Rotate(2,-5); break;
				case 'q' : ObjPos=Position6D_t(ObjPos+point_t(-5,0,0),ObjPos); break;
				case 'w' : ObjPos=Position6D_t(ObjPos+point_t(5,0,0),ObjPos); break;
				case '5' :  break;


				//case ' ' : break;
				//case ' ' : break;
			}
		}else ch=0;
		ObjPos2.Rotate(0,10);  ObjPos2.Rotate(1,10); ObjPos2.Rotate(2,10);
		ObjPos.Rotate(0,10);  ObjPos.Rotate(1,10); ObjPos.Rotate(2,10);
	}while(ch!=27);
}

void Old_Run_Loop(){
	point_t vertex[300];
	pMatrix_t ObjMatrix;
	char ch=0; point2D_t p;
	VertexList VL(num_vertex);
	//SortableList<SortVL> SVL(num_vertex);
	DepthSortIndexList SVL(num_vertex);
	point_t	 P(-5,-5,50), ObjPos(0,0,50);
	rotation3D_t ObjRot(0,0,0);


	vertex[0]=point_t(-1.5,-1.5,0);
	VL.EmptyList();
	VL.Add(vertex[0]);
	int r=0;
	for(int i=1;i<num_vertex;i++){
		point_t p; 		r=(++r)%16; //r = random(6);
		VL.ResetEnd();  		p = VL.Current();//ex[i-1];
		switch (r>>2) {
			case 0 : p=p+point_t( 1, 0, 0); break;
			case 1 : p=p+point_t( 0, 1, 0); break;
			case 2 : p=p+point_t(-1, 0, 0); break;
			case 3 : p=p+point_t( 0,-1, 0); break;
			case 4 : p=p+point_t( 0, 0, 1); break;
			case 5 : p=p+point_t( 0, 0,-1); break;
		}
		VL.Add( (p+point_t(0,0,0.525)) );
	}

	VL.EmptyList();        //Malcolm's fractal
	VL.Add(point_t(0,0,0));
	VL.Add(point_t(1,0,0));
	//VL.Add(point_t(1,1,0));
	for(i=0;i<9;i++){
				ObjMatrix.SetToRotatedAxes(rotation3D_t(0,0,1024));

					VL.ResetEnd(); P=VL.Current();
					do{
						VL.Add( ObjMatrix.UsedOn( VL.Current()-P) + P);

					}while(--VL);
	}

	VL.ResetStart(); i=0;
	point_t mid(0,0,0);
	do{
		VL.Current()=VL.Current()+point_t(0,0,0.025)*i++;
		//mid=mid+VL.Current();
	}while(++VL);
	//mid=(mid*FP_type(1000/i))*0.001;
	mid=VL[i/2];
	VL.ResetStart();
	do{	VL.Current()=VL.Current()-mid; }while(++VL);

	VL.ResetStart();
	//SVL.EmptyList();
	i=0;
	do{	/*SVL.Add(DepthSortIndex(i,0));*/ i++; }while(++VL);

	do{
		FP_type z;
		ch=0;
		x_rect_fill(0,0,ScrnPhysicalPixelWidth, ScrnPhysicalHeight,
								LogicalScr,0);
		ObjMatrix.SetToRotatedAxes(ObjRot);
		//ObjMatrix=pMatrix_t(point_t(1,0,0), point_t(0,1,0), point_t(0,0,1));

		SVL.ResetStart();   //Ready to traverse vertex list  //Prepare loop
		//VL.ResetStart();
		//ListIndex_t ind=0;
		do{
			P=ObjMatrix.UsedOn(VL[SVL.Current().I]);
			P=P+ObjPos;
			z=P*vector3D(0,0,1);
			SVL.Current().Z=z;
			//SVL[ind].I=ind;
			//++SVL;
			//ind++;
		}while(++SVL);

		SVL.SortQ();  //Slow

		SVL.ResetStart();   //Ready to traverse vertex list //DrawLoop
		do{
			P=ObjMatrix.UsedOn(VL[SVL.Current().I]);
			P=P+ObjPos;
			z=SVL.Current().Z;
			int width;
			if( (z)>1){
				FP_type Shade=1;
				p=P.ProjectTo2D();      //Not complete projection
				p=p+point2D_t(ScrnPhysicalPixelWidth>>1,
											ScrnPhysicalHeight>>1); //Move to screen center


					if(z>FallOffDistance) Shade = FallOffDistance/z;
					width = WIDTH/z;
					if( (unsigned int) p.V(0)<ScrnPhysicalPixelWidth
								 && (unsigned int) p.V(1)<ScrnPhysicalHeight)
					if(!width){

							x_put_pix(p.V(0),p.V(1),LogicalScr,char (63*Shade));
					}
					else

						x_rect_fill_clipped(p.V(0)-(width>>1),p.V(1)-(width>>1),
																p.V(0)-(width>>1)+width,p.V(1)-(width>>1)+width,
																//p.V(0)+width,p.V(1)+width,
																LogicalScr, 63*Shade); /**/

				//vertex[i]=vertex[i]-point_t(0,0,1);
			}
			//x_triangle(-10,0,359,0,50,240,0,PageScr[0]);
		}while(++SVL);

		x_wait_vsync();
		PageFlip();
		if(kbhit()){
			ch=getch();
			switch (ch) {
			case '8': ObjRot.Rotate(0,20); break;
			case '2': ObjRot.Rotate(0,-20);break;
			case '4': ObjRot.Rotate(1,20);break;
			case '6': ObjRot.Rotate(1,-20);break;
			case '7': ObjRot.Rotate(2,20); break;
			case '9': ObjRot.Rotate(2,-20); break;
			case '+': ObjPos=ObjPos+point_t(0,0,10);  break;
			case '-': ObjPos=ObjPos+point_t(0,0,-10);  break;
			case ' ':

				break;
			}
		}
		ObjRot.Rotate(2,5);
		ObjRot.Rotate(1,5);
		ObjRot.Rotate(0,5);

		//ObjPos=ObjPos-point_t(0,0,1);

	}while(ch!=27);
}





void Initialize(){
 MyFS3DE = new FlatShading3DEngine;
 Math3D_SetUp_SineTable(); //Cos and Sine
 x_set_mode(X_MODE_320x240,320); //320x400 max res, w/2 pages(256kB limit)
 x_set_doublebuffer(ScrnPhysicalHeight);
 ScreenCenterPoint =  point2D_t(ScrnPhysicalPixelWidth>>1, ScrnPhysicalHeight>>1);
// x_set_cliprect(0,32,80,200);
 PageScr[0] = Page0_Offs;		 PageScr[1] = Page1_Offs;
 for(int i=0;i<64;i++){
	x_set_rgb(i,i,i,i); //White
	x_set_rgb(i+64,i,0,0);
	x_set_rgb(i+2*64,0,i,0);
	x_set_rgb(i+3*64,0,0,i);



 }
 x_text_init();
}

void CleanUp(){
	x_text_mode();
}

void main(int argc, char* argv[])
{

  Initialize();

	Run_Loop();

	CleanUp();

	/*cout<<PovMatrix.p[0]<<"\n";
	cout<<PovMatrix.p[1]<<"\n";
	cout<<PovMatrix.p[2]<<"\n"; */

	for(int i=0;i<argc;cout<<"\n"<<argv[i++]);
	#if !defined(__DOS_H)
		cout<<"__DOS_H not def'ed";
  #endif
}//End of MAIN